'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = function (subscription, functionName, config) {
  return function (ComposedComponent) {
    var _desc, _value, _class;

    var WithSubscription = (_class = function (_React$Component) {
      (0, _inherits3.default)(WithSubscription, _React$Component);

      function WithSubscription(props) {
        (0, _classCallCheck3.default)(this, WithSubscription);

        var _this = (0, _possibleConstructorReturn3.default)(this, (WithSubscription.__proto__ || Object.getPrototypeOf(WithSubscription)).call(this, props));

        _this.client = props.client;
        _this.initialize(props);
        return _this;
      }

      (0, _createClass3.default)(WithSubscription, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          this.startSubscription();
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps, nextContext) {
          var currentVariables = (0, _getVariables2.default)(subscription, config, this.props);
          var nextVariables = (0, _getVariables2.default)(subscription, config, nextProps);
          if ((0, _isEqual2.default)(currentVariables, nextVariables)) {
            return;
          }

          this.initialize(nextProps);
          this.startSubscription();
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.endSubscription();
        }
      }, {
        key: 'initialize',
        value: function initialize(props) {
          if (this.queryObservable) return;
          this.queryObservable = this.client.subscribe({
            query: subscription,
            variables: (0, _getVariables2.default)(subscription, config, props)
          });
        }
      }, {
        key: 'startSubscription',
        value: function startSubscription() {
          if (this.querySubscription) return;
          this.querySubscription = this.queryObservable.subscribe({
            next: this.updateCurrentData,
            error: this.updateError
          });
        }
      }, {
        key: 'updateCurrentData',
        value: function updateCurrentData(result) {
          if (!functionName) return;
          var updater = this.refs.child[functionName];
          if (!updater) {
            return console.log('The second parameter of @withSubscription must be the name of a function in the component. You must put this decorator right before the component');
          }
          updater(result.data);
        }
      }, {
        key: 'updateError',
        value: function updateError(error) {
          console.error('Error in subscription', error);
        }
      }, {
        key: 'endSubscription',
        value: function endSubscription() {
          if (this.querySubscription) {
            this.querySubscription.unsubscribe();
            delete this.querySubscription;
          }
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(ComposedComponent, (0, _extends3.default)({ ref: 'child' }, this.props));
        }
      }]);
      return WithSubscription;
    }(_react2.default.Component), (_applyDecoratedDescriptor(_class.prototype, 'initialize', [_autobindDecorator2.default], Object.getOwnPropertyDescriptor(_class.prototype, 'initialize'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'startSubscription', [_autobindDecorator2.default], Object.getOwnPropertyDescriptor(_class.prototype, 'startSubscription'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'updateCurrentData', [_autobindDecorator2.default], Object.getOwnPropertyDescriptor(_class.prototype, 'updateCurrentData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'updateError', [_autobindDecorator2.default], Object.getOwnPropertyDescriptor(_class.prototype, 'updateError'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'endSubscription', [_autobindDecorator2.default], Object.getOwnPropertyDescriptor(_class.prototype, 'endSubscription'), _class.prototype)), _class);
    WithSubscription.propTypes = {
      client: _propTypes2.default.object
    };


    return (0, _reactApollo.withApollo)(WithSubscription);
  };
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

var _getVariables = require('./getVariables');

var _getVariables2 = _interopRequireDefault(_getVariables);

var _autobindDecorator = require('autobind-decorator');

var _autobindDecorator2 = _interopRequireDefault(_autobindDecorator);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}